summaryrefslogtreecommitdiff
path: root/cross
diff options
context:
space:
mode:
authorcoadde [Márcio Alexandre Silva Delgado] <coadde@parabola.nu>2014-03-15 06:53:44 -0300
committercoadde [Márcio Alexandre Silva Delgado] <coadde@parabola.nu>2014-03-15 06:53:44 -0300
commit2b813b90d639d9072233cd039f3d9b92d4070cfb (patch)
tree934056b5acfeedadd1db7bfdd44caeb3925b0fa9 /cross
parent93c5729a5cbb9922fdee2d6d9db8c962b081b653 (diff)
add [cross-gcc] to [cross] repo
Diffstat (limited to 'cross')
-rw-r--r--cross/cross-gcc/PKGBUILD278
-rw-r--r--cross/cross-gcc/gcc-4.8-filename-output.patch17
-rw-r--r--cross/cross-gcc/gcc-4.8-lambda-ICE.patch35
-rw-r--r--cross/cross-gcc/gcc-xtensa.patch115
-rw-r--r--cross/cross-gcc/gcc.install20
5 files changed, 465 insertions, 0 deletions
diff --git a/cross/cross-gcc/PKGBUILD b/cross/cross-gcc/PKGBUILD
new file mode 100644
index 000000000..f6d29de2c
--- /dev/null
+++ b/cross/cross-gcc/PKGBUILD
@@ -0,0 +1,278 @@
+# $Id: PKGBUILD 105446 2014-02-08 10:44:41Z heftig $
+# Maintainer: Jan Alexander Steffens (heftig) <jan.steffens@gmail.com>
+# Contributor: Allan McRae <allan@archlinux.org>
+# Maintainer: Márcio Silva (Parabola) <coadde@parabola.nu>
+
+# toolchain build order:
+# {kernel}-api-headers->glibc->binutils->gcc->binutils->glibc
+
+# toolchain (for cross-compiler) build order:
+# {kernel}-api-headers(host system)->glibc(host system)
+# ->binutils(host system)->gcc(host system)->binutils(host system)->glibc(host system)
+# ->binutils(cross)->gcc(cross)
+# ->kernel-api-headers(target system)->glibc(target system)
+# ->binutils(target system)->gcc(target system)->binutils(target system)
+# ->glibc(target system)
+
+# NOTE: libtool requires rebuilt with each new gcc version
+
+#--------------------------------------------------------------------------------
+# cross-compile table
+#--------------------------------------------------------------------------------
+
+# +-------------+-------------+-----------------------------------------------------------------------------------------------------+-----------+---------+
+# | -march | CARCH | CTARGET (_CTARGET) | Multilib | QEMU |
+# +-------------+-------------+-------------+-----------+---------------------------------------------------------------------------+-----------+---------+
+# | _march | CARCH | _arch | <machine> | _os_target (GNU/*) | _multilib | - |
+# +-------------+-------------+-------------+-----------+---------------------------------------------------------------------------+-----------+---------+
+# | mips64el | mips64el | mips64el | unknown | {linux,kfreebsd,kopenbsd,knetbsd}-gnu|elf | opt | bin/sys |
+# | mips64 | mips64 | mips64 | unknown | {linux,kfreebsd,kopenbsd,knetbsd}-gnu|elf | opt | bin/sys |
+# | * | mipsel | mipsel | unknown | {linux,kfreebsd,kopenbsd,knetbsd}-gnu|elf | no | bin/sys |
+# | * | mips | mips | unknown | {linux,kfreebsd,kopenbsd,knetbsd}-gnu|elf | no | bin/sys |
+# | x86_64 | x86_64 | x86_64 | unknown | gnu<|{linux,kfreebsd,kopenbsd,knetbsd,kdragonflybsd,kopensolaris}-gnu|elf | yes | bin/sys |
+# | i[3-7]86 | i[3-7]86 | i[3-7]86 | pc | gnu|{linux,kfreebsd,kopenbsd,knetbsd,kdragonflybsd,kopensolaris}-gnu | no | bin/sys |
+# | * | i386 | i386 | unknown | elf | no | bin/sys |
+# | armv8-a | aarch64 | aarch64 | unknown | {linux,kfreebsd,kopenbsd,knetbsd,kopensolaris}-gnu|elf | yes | - |
+# | armv8-a | aarch64_be | aarch64_be | unknown | {linux,kfreebsd,kopenbsd,knetbsd,kopensolaris}-gnu|elf | yes | - |
+# | armv7-a | armv7h | armv7l | unknown | {linux,kfreebsd,kopenbsd,knetbsd,kopensolaris}-gnueabihf|elf | no | bin/sys |
+# | armv6 | armv6h | armv6l | unknown | {linux,kfreebsd,kopenbsd,knetbsd,kopensolaris}-gnueabihf|elf | no | bin/sys |
+# | armv5te | arm | armv5tel | unknown | {linux,kfreebsd,kopenbsd,knetbsd,kopensolaris}-gnueabi | no | bin/sys |
+# | * | arm | arm | unknown | eabi | no | bin/sys |
+# | arm | armeb | armeb | unknown | {linux,kfreebsd,kopenbsd,knetbsd}-gnueabi|eabi | no | bin |
+# | sparc64 | sparc64 | sparc64 | unknown | {linux,kfreebsd,kopenbsd,knetbsd,kopensolaris}-gnu | opt | bin/sys |
+# | sparc | sparc | sparc | unknown | {linux,kopenbsd,knetbsd,kopensolaris}-gnu | no | bin/sys |
+# | - | ia64 | ia64 | unknown | {linux,kfreebsd,kopenbsd,knetbsd}-gnu | yes | - |
+# | - | s390 | s390 | ibm | linux-gnu | no | - |
+# | - | s390x | s390x | ibm | linux-gnu | no | bin/sys |
+#v| powerpc64 | powerpc64 | powerpc64 | unknown | {linux,kfreebsd,kopenbsd,knetbsd}-gnu{,eabi}|{elf,eabi} | opt | bin/sys |x|eabi
+#x| powerpc64le | powerpc64le | powerpc64le | unknown | {linux,kfreebsd,kopenbsd,knetbsd}-gnu{,eabi}|{elf,eabi} | opt | - |
+# | powerpc | powerpc | powerpc | unknown | {linux,kfreebsd,kopenbsd,knetbsd}-gnu{,eabi}|{elf,eabi} | no | bin/sys |
+# | powerpcle | powerpcle | powerpcle | unknown | {linux,kfreebsd,kopenbsd,knetbsd}-gnu{,eabi}|{elf,eabi} | no | - |
+# | - | spu | spu | unknown | elf | no | - |
+# | - | sh64 | sh64 | unknown | {linux,kopenbsd,knetbsd}-gnu|elf | opt | - |
+# | - | sh64le | sh64le | unknown | {linux,kopenbsd,knetbsd}-gnu|elf | opt | - |
+# | - | sh4 | sh4 | unknown | {linux,kopenbsd,knetbsd}-gnu|elf | no | bin/sys |
+# | - | sh4le | sh4le | unknown | {linux,kopenbsd,knetbsd}-gnu|elf | no | bin/sys |
+# | - | sh | sh | unknown | {linux,kopenbsd,knetbsd}-gnu|elf | no | - @ |
+# | - | shle | shle | unknown | {linux,kopenbsd,knetbsd}-gnu|elf | no | - @ |
+# | - | xtensa | xtensa | unknown | elf | no | sys |
+# | * | avr | avr | unknown | elf | no | - |
+# | * | m68k | m68k | unknown | gnu|{linux,kopenbsd,knetbsd}-gnu|elf | no | bin/sys |
+# | - | lm32 | lm32 | unknown | linux-gnu|elf | no | sys |
+# | - | or32 | or32 | unknown | linux-gnu<|elf< | no | bin/sys |x|linux-gnu
+# +-------------+-------------+-------------+-----------+---------------------------------------------------------------------------+-----------+---------+
+
+# For "Wine"
+# +-------------+-------------+-------------+-----------+---------------------------------------------------------------------------+-----------+---------+
+#i| * | x86_64 | x86_64 | unknown | mingw64 | yes | bin/sys |
+#i| * | i[3-7]86 | i[3-7]86 | unknown | mingw32 | no | bin/sys |
+#?| * | aarch64 | aarch64 | unknown | ??? | yes | - |
+#?| * | aarch64_be | aarch64_be | unknown | ??? | yes | - |
+#?| * | armv7h | armv7l | unknown | ??? | no | bin/sys |
+#?| * | armv6h | armv6l | unknown | ??? | no | bin/sys |
+#?| * | arm | armv5tel | unknown | ??? | no | bin/sys |
+#?| * | armeb | armeb | unknown | ??? | no | bin |
+# +-------------+-------------+-------------+-----------+---------------------------------------------------------------------------+-----------+---------+
+
+# For "DOSBox"
+# +-------------+-------------+-------------+-----------+---------------------------------------------------------------------------+-----------+---------+
+#i| * | i386 | i386 | pc | msdosdjgpp | no | bin/sys |
+# +-------------+-------------+-------------+-----------+---------------------------------------------------------------------------+-----------+---------+
+
+# opt : Multilib is optional
+# * : Any supported by architecture.
+# - : None.
+# @ : bin/sys (Only sh4 and sh4l support)
+# < : experimental support. (future)
+
+#--------------------------------------------------------------------------------
+# options
+#--------------------------------------------------------------------------------
+
+# Hardware architecture:
+
+# options: "same", "mips64el", "x86_64", "i686" or "xtensa"
+_arch_target=mips64el
+
+# OS target:
+
+# system: <os> or <kernel>-<os>
+# options: "gnu", "linux-gnu", "kfreebsd-gnu" or "elf"
+_os_target=kfreebsd-gnu
+
+#--------------------------------------------------------------------------------
+# variables
+#--------------------------------------------------------------------------------
+
+# set the default values if it's not added
+[[ -z $_arch_target ]] && _arch_target=same
+[[ -z $_os_target ]] && _os_target=linux-gnu
+
+# set the value on _arch variable
+if [[ $_arch_target == same ]]; then
+ _arch=$CARCH
+else
+ _arch=$_arch_target
+fi
+
+# set the value on _target variable
+if [[ $_arch == i686 ]]; then
+ _target=$_arch-pc-$_os_target
+else
+ _target=$_arch-unknown-$_os_target
+fi
+
+#--------------------------------------------------------------------------------
+
+_pkgname=gcc
+pkgname=$_target-$_pkgname
+makedepends=('binutils>=2.24' 'libmpc' 'cloog' 'doxygen')
+pkgver=4.8.2
+_pkgver=4.8
+pkgrel=8
+_snapshot=4.8-20140206
+pkgdesc="The GNU Compiler Collection"
+arch=('i686' 'x86_64' 'mips64el')
+license=('GPL' 'LGPL' 'FDL' 'custom')
+url="http://$_pkgname.gnu.org"
+checkdepends=('dejagnu' 'inetutils')
+options=('!emptydirs')
+source=(#ftp://$_pkgname.gnu.org/pub/$_pkgname/releases/$_pkgname-${pkgver}/$_pkgname-${pkgver}.tar.bz2
+ ftp://$_pkgname.gnu.org/pub/$_pkgname/snapshots/${_snapshot}/$_pkgname-${_snapshot}.tar.bz2
+ $_pkgname-4.8-filename-output.patch
+ $_pkgname-4.8-lambda-ICE.patch
+ $_pkgname-xtensa.patch)
+md5sums=('9d35549404a2326540fb88301ebd1977'
+ '40cb437805e2f7a006aa0d0c3098ab0f'
+ '6eb6e080dbf7bc6825f53a0aaa6c4ef9'
+ '81372ee980289a9f6df01dad31c64a63')
+
+if [ -n "${_snapshot}" ]; then
+ _basedir=$_pkgname-${_snapshot}
+else
+ _basedir=$_pkgname-${pkgver}
+fi
+
+_libdir="usr/lib/$_pkgname/$_target/$pkgver"
+
+prepare() {
+ cd ${srcdir}/${_basedir}
+
+ # Do not run fixincludes
+ sed -i 's@\./fixinc\.sh@-c true@' $_pkgname/Makefile.in
+
+ # Parabola installs x86_64 libraries /lib
+ [[ $CARCH == "x86_64" ]] && sed -i '/m64=/s/lib64/lib/' $_pkgname/config/i386/t-linux64
+
+ echo ${pkgver} > $_pkgname/BASE-VER
+
+ # hack! - some configure tests for header files using "$CPP $CPPFLAGS"
+ sed -i "/ac_cpp=/s/\$CPPFLAGS/\$CPPFLAGS -O2/" {libiberty,$_pkgname}/configure
+
+ # http://gcc.gnu.org/bugzilla/show_bug.cgi?id=57653
+ patch -p0 -i ${srcdir}/$_pkgname-4.8-filename-output.patch
+
+ # http://gcc.gnu.org/bugzilla//show_bug.cgi?id=56710 - commit 3d1f8279
+ patch -p1 -i ${srcdir}/$_pkgname-4.8-lambda-ICE.patch
+
+ # installing libiberty headers is broken
+ # http://gcc.gnu.org/bugzilla/show_bug.cgi?id=56780#c6
+ sed -i 's#@target_header_dir@#libiberty#' libiberty/Makefile.in
+
+ # open-ath9k-htc-firmware patch on xtensa-unknown-elf
+ [[ $_target == xtensa-unknown-elf ]] && patch -p1 -i ${srcdir}/$_pkgname-xtensa.patch
+
+ mkdir ${srcdir}/$_pkgname-build
+}
+
+build() {
+ cd ${srcdir}/$_pkgname-build
+
+ # using -pipe causes spurious test-suite failures
+ # http://gcc.gnu.org/bugzilla/show_bug.cgi?id=48565
+ CFLAGS=${CFLAGS/-pipe/}
+ CXXFLAGS=${CXXFLAGS/-pipe/}
+
+ ${srcdir}/${_basedir}/configure --prefix=/usr \
+ --libdir=/usr/lib --libexecdir=/usr/lib \
+ --mandir=/usr/share/man --infodir=/usr/share/info \
+ --with-bugurl=https://labs.parabola.nu/ \
+ --enable-languages=c,c++,lto --disable-static \
+ --enable-shared --enable-threads=posix \
+ --with-system-zlib --enable-__cxa_atexit \
+ --disable-libunwind-exceptions --enable-clocale=gnu \
+ --disable-libstdcxx-pch --disable-libssp \
+ --enable-gnu-unique-object --enable-linker-build-id \
+ --enable-cloog-backend=isl --disable-cloog-version-check \
+ --enable-lto --enable-plugin --enable-install-libiberty \
+ --with-linker-hash-style=gnu \
+ --disable-multilib --disable-werror \
+ --enable-checking=release --target=$_target --program-prefix=$_target-
+ make all-$_pkgname
+}
+
+package() {
+ pkgdesc="The GNU Compiler Collection - C and C++ frontends"
+ depends=("$_target-binutils>=2.24" 'libmpc' 'cloog')
+ groups=('cross-devel')
+ provides=("$_pkgname=$pkgver-$pkgrel")
+ conflicts=("$_pkgname" "$_pkgname-ada" "$_pkgname-fortran" "$_pkgname-go" "$_pkgname-objc")
+ install=$_pkgname.install
+
+ cd ${srcdir}/$_pkgname-build
+
+ make -C $_pkgname DESTDIR=${pkgdir} install-driver install-cpp install-$_pkgname-ar \
+ c++.install-common install-headers install-plugin install-lto-wrapper
+
+ install -m755 $_pkgname/gcov $pkgdir/usr/bin/
+ install -m755 -t $pkgdir/${_libdir}/ $_pkgname/{cc1,cc1plus,collect2,lto1}
+
+ make DESTDIR=${pkgdir} install-fixincludes
+ make -C $_pkgname DESTDIR=${pkgdir} install-mkheaders
+ make -C lto-plugin DESTDIR=${pkgdir} install
+
+ make -C libiberty DESTDIR=${pkgdir} install
+
+ make -C $_pkgname DESTDIR=${pkgdir} install-man install-info
+
+ make -C libcpp DESTDIR=${pkgdir} install
+ make -C $_pkgname DESTDIR=${pkgdir} install-po
+
+ # many packages expect this symlinks
+ ln -s $_pkgname ${pkgdir}/usr/bin/cc
+
+ # POSIX conformance launcher scripts for c89 and c99
+ cat > $pkgdir/usr/bin/c89 <<"EOF"
+#!/bin/sh
+fl="-std=c89"
+for opt; do
+ case "$opt" in
+ -ansi|-std=c89|-std=iso9899:1990) fl="";;
+ -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
+ exit 1;;
+ esac
+done
+exec gcc $fl ${1+"$@"}
+EOF
+
+ cat > $pkgdir/usr/bin/c99 <<"EOF"
+#!/bin/sh
+fl="-std=c99"
+for opt; do
+ case "$opt" in
+ -std=c99|-std=iso9899:1999) fl="";;
+ -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
+ exit 1;;
+ esac
+done
+exec gcc $fl ${1+"$@"}
+EOF
+
+ chmod 755 $pkgdir/usr/bin/c{8,9}9
+
+ # link files
+ for bin2 in c++ cpp g++ gcc gcc-ar gcc-nm gcc-ranlib; do
+ ln -s $_target-$bin2 $pkgdir/usr/bin/$bin2; done
+ for man in $(ls -1 $pkgdir/usr/share/man/man1); do
+ ln -s $man $pkgdir/usr/share/man/man1/${man#$_target-}; done
+}
diff --git a/cross/cross-gcc/gcc-4.8-filename-output.patch b/cross/cross-gcc/gcc-4.8-filename-output.patch
new file mode 100644
index 000000000..6951eb239
--- /dev/null
+++ b/cross/cross-gcc/gcc-4.8-filename-output.patch
@@ -0,0 +1,17 @@
+--- gcc/c-family/c-opts.c (revision 200330)
++++ gcc/c-family/c-opts.c (working copy)
+@@ -1338,10 +1338,14 @@ c_finish_options (void)
+
+ /* Give CPP the next file given by -include, if any. */
+ static void
+ push_command_line_include (void)
+ {
++ // This can happen if disabled by -imacros for example.
++ if (include_cursor > deferred_count)
++ return;
++
+ if (!done_preinclude)
+ {
+ done_preinclude = true;
+ if (flag_hosted && std_inc && !cpp_opts->preprocessed)
+ {
diff --git a/cross/cross-gcc/gcc-4.8-lambda-ICE.patch b/cross/cross-gcc/gcc-4.8-lambda-ICE.patch
new file mode 100644
index 000000000..cf77a9b35
--- /dev/null
+++ b/cross/cross-gcc/gcc-4.8-lambda-ICE.patch
@@ -0,0 +1,35 @@
+diff --git a/gcc/cp/semantics.c b/gcc/cp/semantics.c
+index 0b8e2f7..ad1c209 100644
+--- a/gcc/cp/semantics.c
++++ b/gcc/cp/semantics.c
+@@ -2719,8 +2719,10 @@ finish_member_declaration (tree decl)
+ /*friend_p=*/0);
+ }
+ }
+- /* Enter the DECL into the scope of the class. */
+- else if (pushdecl_class_level (decl))
++ /* Enter the DECL into the scope of the class, if the class
++ isn't a closure (whose fields are supposed to be unnamed). */
++ else if (CLASSTYPE_LAMBDA_EXPR (current_class_type)
++ || pushdecl_class_level (decl))
+ {
+ if (TREE_CODE (decl) == USING_DECL)
+ {
+diff --git a/gcc/testsuite/g++.dg/cpp0x/lambda/lambda-names1.C b/gcc/testsuite/g++.dg/cpp0x/lambda/lambda-names1.C
+new file mode 100644
+index 0000000..df2b037
+--- /dev/null
++++ b/gcc/testsuite/g++.dg/cpp0x/lambda/lambda-names1.C
+@@ -0,0 +1,9 @@
++// PR c++/56710
++// { dg-options "-std=c++11 -Wall" }
++
++int main()
++{
++ int t = 0;
++ return [&]() -> int {int __t; __t = t; return __t; }();
++ return [&t]() -> int {int __t; __t = t; return __t; }();
++}
+--
+1.8.4.2
+
diff --git a/cross/cross-gcc/gcc-xtensa.patch b/cross/cross-gcc/gcc-xtensa.patch
new file mode 100644
index 000000000..9f43902be
--- /dev/null
+++ b/cross/cross-gcc/gcc-xtensa.patch
@@ -0,0 +1,115 @@
+From c7162b8a3db42e7faf47606d3aa3dd61e64aea17 Mon Sep 17 00:00:00 2001
+From: Sujith Manoharan <c_manoha@qca.qualcomm.com>
+Date: Mon, 7 Jan 2013 16:06:28 +0530
+Subject: [PATCH] gcc: AR9271/AR7010 config
+
+Signed-off-by: Sujith Manoharan <c_manoha@qca.qualcomm.com>
+---
+ include/xtensa-config.h | 36 +++++++++++++++++-------------------
+ 1 file changed, 17 insertions(+), 19 deletions(-)
+
+diff --git a/include/xtensa-config.h b/include/xtensa-config.h
+index 30f4f41..fe9b051 100644
+--- a/include/xtensa-config.h
++++ b/include/xtensa-config.h
+@@ -1,7 +1,7 @@
+ /* Xtensa configuration settings.
+- Copyright (C) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2010
++ Copyright (C) 2001, 2002, 2003, 2004, 2005, 2006, 2007
+ Free Software Foundation, Inc.
+- Contributed by Bob Wilson (bob.wilson@acm.org) at Tensilica.
++ Contributed by Bob Wilson (bwilson@tensilica.com) at Tensilica.
+
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+@@ -44,10 +44,7 @@
+ #define XCHAL_HAVE_L32R 1
+
+ #undef XSHAL_USE_ABSOLUTE_LITERALS
+-#define XSHAL_USE_ABSOLUTE_LITERALS 0
+-
+-#undef XSHAL_HAVE_TEXT_SECTION_LITERALS
+-#define XSHAL_HAVE_TEXT_SECTION_LITERALS 1 /* Set if there is some memory that allows both code and literals. */
++#define XSHAL_USE_ABSOLUTE_LITERALS 1
+
+ #undef XCHAL_HAVE_MAC16
+ #define XCHAL_HAVE_MAC16 0
+@@ -59,10 +56,10 @@
+ #define XCHAL_HAVE_MUL32 1
+
+ #undef XCHAL_HAVE_MUL32_HIGH
+-#define XCHAL_HAVE_MUL32_HIGH 0
++#define XCHAL_HAVE_MUL32_HIGH 1
+
+ #undef XCHAL_HAVE_DIV32
+-#define XCHAL_HAVE_DIV32 1
++#define XCHAL_HAVE_DIV32 0
+
+ #undef XCHAL_HAVE_NSA
+ #define XCHAL_HAVE_NSA 1
+@@ -103,8 +100,6 @@
+ #undef XCHAL_HAVE_FP_RSQRT
+ #define XCHAL_HAVE_FP_RSQRT 0
+
+-#undef XCHAL_HAVE_DFP_accel
+-#define XCHAL_HAVE_DFP_accel 0
+ #undef XCHAL_HAVE_WINDOWED
+ #define XCHAL_HAVE_WINDOWED 1
+
+@@ -119,32 +114,32 @@
+
+
+ #undef XCHAL_ICACHE_SIZE
+-#define XCHAL_ICACHE_SIZE 16384
++#define XCHAL_ICACHE_SIZE 0
+
+ #undef XCHAL_DCACHE_SIZE
+-#define XCHAL_DCACHE_SIZE 16384
++#define XCHAL_DCACHE_SIZE 0
+
+ #undef XCHAL_ICACHE_LINESIZE
+-#define XCHAL_ICACHE_LINESIZE 32
++#define XCHAL_ICACHE_LINESIZE 16
+
+ #undef XCHAL_DCACHE_LINESIZE
+-#define XCHAL_DCACHE_LINESIZE 32
++#define XCHAL_DCACHE_LINESIZE 16
+
+ #undef XCHAL_ICACHE_LINEWIDTH
+-#define XCHAL_ICACHE_LINEWIDTH 5
++#define XCHAL_ICACHE_LINEWIDTH 4
+
+ #undef XCHAL_DCACHE_LINEWIDTH
+-#define XCHAL_DCACHE_LINEWIDTH 5
++#define XCHAL_DCACHE_LINEWIDTH 4
+
+ #undef XCHAL_DCACHE_IS_WRITEBACK
+-#define XCHAL_DCACHE_IS_WRITEBACK 1
++#define XCHAL_DCACHE_IS_WRITEBACK 0
+
+
+ #undef XCHAL_HAVE_MMU
+ #define XCHAL_HAVE_MMU 1
+
+ #undef XCHAL_MMU_MIN_PTE_PAGE_SIZE
+-#define XCHAL_MMU_MIN_PTE_PAGE_SIZE 12
++#define XCHAL_MMU_MIN_PTE_PAGE_SIZE 29
+
+
+ #undef XCHAL_HAVE_DEBUG
+@@ -157,8 +152,11 @@
+ #define XCHAL_NUM_DBREAK 2
+
+ #undef XCHAL_DEBUGLEVEL
+-#define XCHAL_DEBUGLEVEL 6
++#define XCHAL_DEBUGLEVEL 4
++
+
++#undef XCHAL_EXCM_LEVEL
++#define XCHAL_EXCM_LEVEL 3
+
+ #undef XCHAL_MAX_INSTRUCTION_SIZE
+ #define XCHAL_MAX_INSTRUCTION_SIZE 3
+--
+1.8.1
+
diff --git a/cross/cross-gcc/gcc.install b/cross/cross-gcc/gcc.install
new file mode 100644
index 000000000..3407a5e1f
--- /dev/null
+++ b/cross/cross-gcc/gcc.install
@@ -0,0 +1,20 @@
+infodir=usr/share/info
+filelist=(cpp.info cppinternals.info gcc.info gccinstall.info gccint.info)
+
+post_install() {
+ [ -x usr/bin/install-info ] || return 0
+ for file in ${filelist[@]}; do
+ install-info $infodir/$file.gz $infodir/dir 2> /dev/null
+ done
+}
+
+post_upgrade() {
+ post_install $1
+}
+
+pre_remove() {
+ [ -x usr/bin/install-info ] || return 0
+ for file in ${filelist[@]}; do
+ install-info --delete $infodir/$file.gz $infodir/dir 2> /dev/null
+ done
+}